#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cstring>
#include<cassert>
#include<string>
#include<vector>
#include<algorithm>
#define infile "secvente.in"
#define tmax 100

using namespace std;

struct test
{
  int v, n;
} t[tmax];
int nr; //tests number

vector <bool> vz;
vector <int> v[2];
vector <int> w;

inline int randomValue(int a, int b)
{
  return (rand()%(b-a+1)) + a;
}

string makeString(int x)
{
  if(!x) return "0";
  string str;
  while(x)
    str = char((x%10) + '0') + str, x /= 10;
  return str;
}

void init()
{
  nr=20;
  t[1].n=13;            t[1].v=31;
  t[2].n=31;            t[2].v=131;
  t[3].n=131;           t[3].v=313;
  t[4].n=313;           t[4].v=99999;
  t[5].n=666;           t[5].v=131313;
  t[6].n=789;           t[6].v=313131;
  t[7].n=999;           t[7].v=555555;
  t[8].n=31313;         t[8].v=666666;
  t[9].n=50000;         t[9].v=777777;
  t[10].n=66666;        t[10].v=888888;
  t[11].n=99999;        t[11].v=999999;
  t[12].n=100000;       t[12].v=999999;
  t[13].n=131313;       t[13].v=999999;
  t[14].n=150013;       t[14].v=999999;
  t[15].n=166613;       t[15].v=999999;
  t[16].n=177777;       t[16].v=999999;
  t[17].n=188888;       t[17].v=999999;
  t[18].n=199999;       t[18].v=999999;
  t[19].n=200000;       t[19].v=999999;
  t[20].n=200000;       t[20].v=999999;
}

void generate(struct test t, int nr)
{ //generate test number nr
  string file = makeString(nr) + "-" + infile;
  freopen(file.c_str(), "w", stdout);

  w.clear();
  vz.clear();

  vz.resize(t.v, false);

  v[0].clear();
  v[1].clear();

  int lenA = t.n/4;
  int lenB = t.n - lenA;

  for (int i = 0, j = randomValue(lenA, t.v - lenA - lenB); i < lenB; ++i, ++j) {
      v[1].push_back(j);
      vz[j] = true;
  }

  reverse(v[1].begin(), v[1].begin() + v[1].size() / 3);
  random_shuffle(v[1].begin() + v[1].size()/3, v[1].begin() + 2*v[1].size()/3);

  for (int i = 0; i < lenA; ++i) {
      while(true) {
          int x = randomValue(1, t.v);
          if (vz[x] == false) {
              v[0].push_back(x);
              vz[x] = true;
              break;
          }
      }
  }

  w.insert(w.end(), v[0].begin(), v[0].begin() + v[0].size() / 2);
  w.insert(w.end(), v[1].begin(), v[1].end());
  w.insert(w.end(), v[0].begin() + v[0].size() / 2, v[0].end());

  assert(w.size() == (unsigned)t.n);

  printf("%d\n", t.n);

  for (unsigned i = 0; i < w.size(); ++i) {
      printf("%d\n", w[i]);
  }

  fclose(stdout);
}

int main()
{
  srand((unsigned)time(0));
  init();

  for(int i = 1; i <= nr; ++i)
    generate(t[i],i);

  return 0;
}
